/*================================================================================
	PIC16wKLbgp
	A-DRo[^̃eXg
	AN_TR̒lɂALED̖邳𒲐

	File Name      : PwmLed.c
	Target Compiler: PICC-Lite
	Verion         : 1.0
	Last Update    : 06-Feb-2009 19:03

  ================================================================================ */
  
#include <pic.h>

     __CONFIG(INTCLK & WDTDIS & PWRTDIS & MCLRDIS & UNPROTECT & BORDIS & IESODIS & FCMDIS);

// PICCsamplesɊ܂܂delay֐𗬗p
#define XTAL_FREQ 8MHZ
#include "delay.h"

//Helper Macros
#define clear_bit( reg, bitNumb )	((reg) &= ~(1 << (bitNumb)))
#define set_bit( reg, bitNumb )		((reg) |= (1 << (bitNumb)))
#define test_bit( reg, bitNumb )	((reg) & (1 << (bitNumb)))
#define toggle_bit( reg, bitNumb )	((reg) ^= (1 << (bitNumb)))

void interrupt f_int( void )
{

}

//A-DRo[^
void EnableAD(void)
{
	set_bit(ADCON0,0); 
}

void StartAD(void)
{
	ADCON0=3; 

}
char ADBusy(void)
{
	return test_bit(ADCON0,1);
}

unsigned char GetAD(void)
{
	return ADRESH;
}

void LedCont(unsigned char val)
{
	char i;
	unsigned char nval;
	
	nval=255-val;
	for(i=0;i<10;i++){
		if(val)
			PORTC=0x0f;
		else
			PORTC=0;
		DelayUs(val);
		PORTC=0;
		DelayUs(nval);
	}
}

//I/O|[g̏
void IoInit(void)
{
	//Port Setting
	OSCCON=0x70;	//CLK=8MHz(Internal)
	//Port Setting
	TRISA = 0x09;	//RA0,RA3=INPUT
	TRISB = 0x20;	//RB5=INPUT
	TRISC = 0x00;	//OUTPUT
	PORTA=0;
	PORTB=0;
	PORTC=0;
	ANSEL=1;		//RA0->ANALOG
	ANSELH=0;
	//A-D Setting
	ADCON0 = 1;			// Enable A/D ch0
	ADCON1 = 0x50;		// A/D CLOCK=fosc/16
}
 

void main( void )
{
	unsigned char val;
	DelayMs(100);	//ZbgAn[hEFA肷܂ő҂
	IoInit();	//I/O|[g
	DelayMs(100);
	EnableAD();
	while(1){
		//A-Df[^̓ǂݍ
#if 1
		StartAD();			//A-ĎvJn
		while(ADBusy());	//A-D̊҂
		val=GetAD();		//A-D̒l̓ǂݍ
#else
		val=0x80;
#endif		
		LedCont(val);
	}
}
