/*================================================================================
	PIC16wKLbgp
	A-DRo[^̃eXg
	AN_TR̒lɂALED̖邳𒲐

	File Name      : PwmLed.c
	Target Compiler: Boost-C
	Verion         : 1.0
	Last Update    : 06-Feb-2009 19:11

  ================================================================================ */
#include <system.h>

//NbNg̐ݒi8MHz)
#pragma CLOCK_FREQ	8000000
#pragma DATA _CONFIG,_INTRC_OSC_NOCLKOUT & _WDT_OFF & _PWRTE_OFF & _MCLRE_OFF & _CP_OFF & _BOR_OFF & _IESO_OFF & _FCMEN_OFF;


void interrupt( void )
{

} 

//A-DRo[^
void EnableAD(void)
{
	set_bit(adcon0,0); 
}

void StartAD(void)
{
	set_bit(adcon0,1); 
}

char ADBusy(void)
{
	return test_bit(adcon0,1);
}

unsigned char GetAD(void)
{
	return adresh;
}

void LedCont(unsigned char val)
{
	char i;
	unsigned char nval;
	
	nval=255-val;
	for(i=0;i<10;i++){
		if(val)
			portc=0x0f;
		else
			portc=0;
		delay_us(val);
		portc=0;
		delay_us(nval);
	}
}

//I/O|[g̏
void IoInit()
{
	//Port Setting
	osccon=0x70;	//CLK=8MHz(Internal)
	//Port Setting
	trisa = 0x09;	//RA0,RA3=INPUT
	trisb = 0x20;	//RB5=INPUT
	trisc = 0x00;	//OUTPUT
	porta=0;
	portb=0;
	portc=0;
	ansel=1;		//RA0->ANALOG
	anselh=0;
	//A-D Setting
	adcon0 = 1;			// Enable A/D ch0
	adcon1 = 0x50;		// A/D CLOCK=fosc/16
}
 

void main( void )
{
	unsigned char val;
	delay_ms(100);	//ZbgAn[hEFA肷܂ő҂
	IoInit();	//I/O|[g
	EnableAD();
	delay_ms(100);
	while(1){
		//A-Df[^̓ǂݍ
#if 1
		StartAD();			//A-ĎvJn
		while(ADBusy());	//A-D̊҂
		val=GetAD();		//A-D̒l̓ǂݍ
#else
		val=0x80;
#endif		
		LedCont(val);
	}
}
